-- Dragon's Lair for PSP with LUA
-- Author: TechnopodMan
-- Version: 0.2

-- Define variables
oldPad = pad
subs=0
negro = Color.new(0, 0, 0)
blanco = Color.new(255, 255, 255)
currentTime = nil
counter = nil
counter = Timer.new()

-- Pantallas de Seleccion, creditos, controles etc...
imgfondo=Image.load("imgs/fondo.jpg")
imgselector=Image.load("imgs/selector.jpg")
imgcreditos=Image.load("imgs/creditos.jpg")
imgopciones=Image.load("imgs/opciones.jpg")
imgcontroles=Image.load("imgs/controles.jpg")
imgsalir=Image.load("imgs/dl_off.jpg")
imgsubs=Image.load("imgs/subtitulos.jpg")
sndmenu=Sound.load("snd/snd2.wav", true)

-- Comienza el sonido
local sonido = sndmenu
sonidofondo = sonido:play()

-- Funcion de inicio del juego
function inicio()

-- Mostrar pantalla de selector
oldPad = pad
while true do
screen:clear()
screen:blit(0, 0, imgselector)
screen.waitVblankStart()
if subs == 1 then
screen:print(315,125,text1,negro)
screen:print(325,165,text2,negro)
screen:print(325,205,text3,negro)
end
screen.flip()
screen.waitVblankStart()
imgsubtitles=nil
pad = Controls.read()
if pad ~= oldPad then
if pad:cross() then
oldPad = pad
jugar()
end
if pad:square() then
oldPad = pad
creditos()
end
if pad:circle() then
oldPad = pad
opciones()
end
end
end
end

-- Funcion de mostrar creditos
function creditos()
oldPad = pad

-- Mostrar pantalla de creditos
while true do
screen:clear()
screen:blit(0, 0, imgcreditos)
screen.waitVblankStart()
if subs == 0 then
screen:print(113,40,"Esta version se ha creado sin animo de lucro",negro)
screen:print(113,50,"unicamente por diversion y reto personal. En",negro)
screen:print(113,60,"ningun caso se ha intentado violar los dere-",negro)
screen:print(113,70,"chos de autor que pertenecen a:             ",negro)
screen:print(113,90,"Dragon's Lair y Space Ace son marcas regis -",negro)
screen:print(113,100,"tradas de Bluth Group Ltd.                  ",negro)
screen:print(113,110,"Creacion de personajes Don Bluth (1983).   ",negro)
screen:print(113,120,"Remasterizado por acuerdo de Digital Leisu -",negro)
screen:print(113,130,"re, Inc. y Dragon's Lair LLC.               ",negro)
screen:print(113,140,"Version en Castellano por FX Interactive    ",negro)
screen:print(113,150,"(2001)                                      ",negro)
screen:print(113,170,"Version para Sony PSP basada en LUA por:    ",negro)
screen:print(113,180,"TECHNOPODMAN (2006-2008)                    ",negro)
end
if subs == 1 then
screen:print(113,40,credits1,negro)
screen:print(113,50,credits2,negro)
screen:print(113,60,credits3,negro)
screen:print(113,70,credits4,negro)
screen:print(113,90,credits5,negro)
screen:print(113,100,credits6,negro)
screen:print(113,110,credits7,negro)
screen:print(113,120,credits8,negro)
screen:print(113,130,credits9,negro)
screen:print(113,140,credits10,negro)
screen:print(113,150,credits11,negro)
screen:print(113,170,credits12,negro)
screen:print(113,180,credits13,negro)
end
screen.flip()
screen.waitVblankStart()
pad = Controls.read()
if pad ~= oldPad then
if pad:triangle() then
oldPad = pad
inicio()
end
end
end
end

-- Funcion mostrar opciones
function opciones()
oldPad = pad

-- Mostrar pantalla de opciones
while true do
screen:clear()
screen:blit(0, 0, imgopciones)
screen.waitVblankStart()
if subs == 1 then
screen:print(130,255,text4,blanco)
screen:print(210,255,text5,blanco)
screen:print(335,255,text7,blanco)
screen:print(390,255,text6,blanco)
end
screen.flip()
screen.waitVblankStart()
pad = Controls.read()
if pad ~= oldPad then
if pad:cross() then
oldPad = pad
controles()
end
if pad:square() then
oldPad = pad
vidas = 0
salir()
end
if pad:triangle() then
oldPad = pad
inicio()
end
if pad:start() then
oldpad = pad
dofile("djpcboard.pcb")
if subs == 0 then
screen:print(250,170,"PARTIDA CARGADA",negro)
screen.flip()
end
if subs == 1 then
screen:print(250,170,text13,negro)
screen.flip()
end
end
end
end
end

-- Funcion salir del juego
function salir()

-- Mostrar pantalla de salida
if vidas == 0 then
screen:clear()
screen:blit(0, 0, imgsalir)
screen.waitVblankStart()
screen.flip()
screen.waitVblankStart(80)
 os.exit()
end
end

-- Funcion mostrar controles
function controles()
oldPad = pad

-- Mostrar pantalla de controles
while true do
screen:clear()
screen:blit(0, 0, imgcontroles)
screen.waitVblankStart()
if subs == 1 then
screen:print(120,220,text8,negro)
screen:print(320,220,text9,negro)
end
screen.flip()
screen.waitVblankStart()
pad = Controls.read()
if pad ~= oldPad then
if pad:triangle() then
oldPad = pad
inicio()
end
end
end
end 

-- Funcion comienzo del juego
function jugar()
sonidofondo:stop()

-- Comienzo del juego
while true do
screen:clear()
screen:blit(0, 0, imgfondo)
screen.waitVblankStart()
screen.flip()
screen.waitVblankStart()
dofile("cargado.lua")
end
end

-- Mostrar pantalla de subtitulos
oldPad = pad
-- Carga de subtitulos
dofile("./subs.txt")
while true do
screen:clear()
screen:blit(0, 0, imgsubs)
screen.waitVblankStart()
screen.flip()
screen.waitVblankStart()
imglua=nil
imginicio=nil
pad = Controls.read()
if pad ~= oldPad then
if pad:select() then
oldPad = pad
subs=1
screen:print(200,148,text11,negro)
screen.flip() 
counter:start()
currentTime = nil
while  true  do
currentTime = counter:time()
if currentTime > 10000 then
currenTime = nil
counter:reset(0)
oldPad = pad
inicio()
end
end
end
if pad:start() then
oldPad = pad
inicio()
end
end
end

-- Desarrollo del juego
inicio()